=== src/errors/CMakeLists.txt ===
collect_sources(SFSERR)

shared_add_library(sfserr ${SFSERR_SOURCES})
