=== debian/changelog ===
saunafs (5.1.2-1ubuntu1) resolute; urgency=medium

  * Fix FTBFS (LP: #2142100)
  * Fix filelimits using wrong user
  * Fix sleep not stopping chunkserver
  * Replace references of LizardFS to SaunaFS in remaining files

 -- Urmas Rist <urmas@urist.ee>  Tue, 17 Feb 2026 17:03:05 +0000

saunafs (5.1.2-1) unstable; urgency=medium

  * Initial release (Closes: #1080956)

 -- Urmas Rist <urmas@urist.ee>  Thu, 28 Aug 2025 16:32:26 +0000
