=== debian/control ===
Source: saunafs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders: Urmas Rist <urmas@urist.ee>
Section: admin
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               bash-completion,
               python3,
               cmake,
               asciidoc,
               libxml2-utils,
               docbook-xml,
               docbook-xsl,
               xsltproc,
               pkgconf,
# libcrcutil is for little-endian architectures only.
               libcrcutil-dev [!hppa !m68k !mips !powerpc !powerpcspe !ppc64 !s390 !s390x !sparc !sparc64],
               libfuse3-dev,
               libdb-dev,
               libyaml-cpp-dev,
               prometheus-cpp-dev,
#_beware:     ,libgoogle-perftools-dev
               googletest,
               libisal-dev [amd64 kfreebsd-amd64],
               libjudy-dev,
               libpam-dev,
               libspdlog-dev,
               libsystemd-dev [!kfreebsd-any],
#             ,libthrift-dev
               zlib1g-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libfmt-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/hpc-team/saunafs
Vcs-Git: https://salsa.debian.org/hpc-team/saunafs.git
Homepage: https://saunafs.com/
Rules-Requires-Root: no

# Vcs-Browser: https://salsa.debian.org/debian/saunafs
# Vcs-Git: https://salsa.debian.org/debian/saunafs.git
Package: saunafs-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         adduser
Description: SaunaFS - common files
 Files and users common for all SaunaFS applications.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-master
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
# TODO: Source version should generally be equal
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - master server
 SaunaFS master (metadata) server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-metalogger
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - metalogger server
 SaunaFS metadata replication (backup) server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-chunkserver
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         saunafs-common (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: SaunaFS - data server
 The SaunaFS data server.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-client
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: fuse
Built-Using: ${my:Built-Using}
Description: SaunaFS - client tools and mount utility
 SaunaFS FUSE mount utility "sfsmount" and client tool "saunafs".
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
  master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-adm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Built-Using: ${my:Built-Using}
Description: SaunaFS - administration tools
 SaunaFS administration tool: saunafs-admin
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-cgiserv
Architecture: any
Depends: ${misc:Depends},
#       ,saunafs-cgi
         saunafs-common (>= ${source:Version}),
         python3-legacy-cgi,
         python3
Built-Using: ${my:Built-Using}
Description: simple CGI-capable HTTP server to run SaunaFS CGI monitor
 Simple standalone CGI-capable HTTP server to run SaunaFS CGI Monitor.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.

Package: saunafs-uraft
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
#       ,saunafs-cgi
         saunafs-common (>= ${source:Version}),
         saunafs-adm (>= ${source:Version}),
         saunafs-master (>= ${source:Version})
Built-Using: ${my:Built-Using}
Description: Raft-like algorithm tool for SaunaFS
 HA tool based on the Raft algorithm.
 .
 SaunaFS is a distributed, FUSE filesystem that is focused on reliability and
 data integrity.
 .
 Some of the features include:
  * Erasure-coding (EC) for files.
  * Real-time journaling for recovery of metadata and auditing.
  * Copy-on write snapshots of files.
  * Extra protection when reading/writing data through CRC.
  * High-availability and optional automatic failover to one or more shadow
    master servers.
 .
 SaunaFS is a fork of LizardFS.
